function str2buf(str){return new TextEncoder("utf-8").encode(str);}
function buf2str(buffer){return new TextDecoder("utf-8").decode(buffer);}
function hex2buf(hexStr){return new Uint8Array(hexStr.match(/.{2}/g).map(h=>parseInt(h,16)));}
function buf2hex(buffer){return Array.prototype.slice.call(new Uint8Array(buffer)).map(x=>[x>>4,x&15]).map(ab=>ab.map(x=>x.toString(16)).join("")).join("");}
function deriveKey(passphrase,salt){salt=salt||crypto.getRandomValues(new Uint8Array(8));return crypto.subtle.importKey("raw",str2buf(passphrase),"PBKDF2",false,["deriveKey"]).then(key=>crypto.subtle.deriveKey({name:"PBKDF2",salt,iterations:1000,hash:"SHA-256"},key,{name:"AES-GCM",length:256},false,["encrypt","decrypt"],),).then(key=>[key,salt]);}
function encrypt(passphrase,plaintext){const iv=crypto.getRandomValues(new Uint8Array(12));const data=str2buf(plaintext);return deriveKey(passphrase).then(([key,salt])=>crypto.subtle.encrypt({name:"AES-GCM",iv},key,data).then(ciphertext=>`${buf2hex(salt)}-${buf2hex(iv)}-${buf2hex(ciphertext)}`),);}
function decrypt(passphrase,saltIvCipherHex){const[salt,iv,data]=saltIvCipherHex.split("-").map(hex2buf);return deriveKey(passphrase,salt).then(([key])=>crypto.subtle.decrypt({name:"AES-GCM",iv},key,data)).then(v=>buf2str(new Uint8Array(v)));}